<?php
/**
* This file contains the install routine for Jgen
*
* Jgen is copyright (c) Solventus.tk
**/

// no direct access
defined('_VALID_MOS') or die('Restricted access');

function com_install() {
	global $mosConfig_absolute_path;
	global $database;
	global $mosConfig_host;
	global $mosConfig_user;
	global $mosConfig_password;

	//Set the menu-icon
	$database->setQuery("UPDATE #__components SET admin_menu_img='../administrator/components/com_jgen/images/jgen_menu.png' WHERE admin_menu_link='option=com_jgen'");
	$database->query();
	
	//Check if the image folder exists and (if not) create one.
	//
	echo "Testing existence of image folder: ";
	if ($dir = @opendir($mosConfig_absolute_path."/images/Jgen")) {
		//The correct folder already exists so we don't have to do anything
		echo "The image-folder already exists<br>";
	} else {
		//The folder does not exists so we have to create it
		mkdir ($mosConfig_absolute_path."/images/Jgen");
		echo "Image-folder created<br>";
	}

	//As of 0.9.56 we have to add some fields
	echo "Testing database updates for 0.9.56: ";
	$query = "SELECT * FROM `INFORMATION_SCHEMA`.`COLUMNS` WHERE `TABLE_NAME`='jgen_individuals' AND `COLUMN_NAME`='BurialDate';";
	$database->setQuery($query);
	$database->loadObject($result);
	if($result->ORDINAL_POSITION == "") {
		//If this field does not exist the updates for 0.9.56 have not been performed
		$query = "ALTER TABLE `jgen_individuals` ";
		$query.= "ADD `BurialDate` DATE NOT NULL AFTER `DiePlace`,";
		$query.= "ADD `BurialPlace` VARCHAR( 25 ) NOT NULL AFTER `BurialDate`,";
		$query.= "Add `NoFirstName` char(1) NOT NULL AFTER `FirstName`;";
		$database->setQuery($query);
		$database->query();
		echo "Database modifications for release 0.9.56 performed.<br>";
	} else {
		echo "Database modifications already in place.<br>";
	}

	//As of 0.9.63 we have to add some fields
	echo "Testing database updates for 0.9.63: ";
	unset($result);
	$query = "SELECT * FROM `INFORMATION_SCHEMA`.`COLUMNS` WHERE `TABLE_NAME`='jgen_individuals' AND `COLUMN_NAME`='BirthDateMod';";
	$database->setQuery($query);
	$database->loadObject($result);
	if($result->ORDINAL_POSITION == "") {
		//If this field does not exist the updates for 0.9.63 have not been performed
		$query = "ALTER TABLE `jgen_individuals` ";
		$query.= "ADD `BirthDate2` DATE NOT NULL AFTER `BirthDate`,";
		$query.= "ADD `BirthDateMod` VARCHAR(10) NOT NULL AFTER `BirthDate2`,";
		$query.= "ADD `ChristDate2` DATE NOT NULL AFTER `ChristDate`,";
		$query.= "ADD `ChristDateMod` VARCHAR(10) NOT NULL AFTER `ChristDate2`,";
		$query.= "ADD `DieDate2` DATE NOT NULL AFTER `DieDate`,";
		$query.= "ADD `DieDateMod` VARCHAR(10) NOT NULL AFTER `DieDate2`,";
		$query.= "ADD `BurialDate2` DATE NOT NULL AFTER `BurialDate`,";
		$query.= "ADD `BurialDateMod` VARCHAR(10) NOT NULL AFTER `BurialDate2`;";
		$database->setQuery($query);
		$database->query();
		echo "Database modifications for release 0.9.63 performed.<br>";
	} else {
		echo "Database modifications already in place.<br>";
	}

	//As of 0.9.66 we have to add some fields
	echo "Testing database updates for 0.9.66: ";
	unset($result);
	$query = "SELECT * FROM `INFORMATION_SCHEMA`.`COLUMNS` WHERE `TABLE_NAME`='jgen_individuals' AND `COLUMN_NAME`='HideToday';";
	$database->setQuery($query);
	$database->loadObject($result);
	if($result->ORDINAL_POSITION == "") {
		//If this field does not exist the updates for 0.9.66 have not been performed
		$query = "ALTER TABLE `jgen_individuals` ";
		$query.= "ADD `HideToday` char(1) NOT NULL AFTER `Profession`;";
		$database->setQuery($query);
		$database->query();
		echo "Database modifications for release 0.9.66 performed.<br>";
	} else {
		echo "Database modifications already in place.<br>";
	}



	//We have finished installing
	//
	echo "<br><b><u>Congratulations</u></b> Jgen has been successfully installed<br>";
	echo "<br>";
	echo "For more information and news about new versions of Jgen please visit our website.<br>";
	echo "<a href='http://www.solventus.nl'><b>www.solventus.nl</b></a><br><br>";
	echo "<br>(c) solventus.nl http://www.solventus.nl<br>";
}
